;##################################################################
; GdipExample
;##################################################################

// Build commands:
// GoAsm.EXE /x86 /d UNICODE "GdipExample.asm"
// GoLink.EXE  "GdipExample.obj" "GdipExample.res"

STRINGS UNICODE

#include "GdipExample.h"

DATA SECTION
	hInstance		HANDLE ?
	GDIPlusToken	ULONG_PTR 0
	gdipsi			GdiplusStartupInput	<1,0,0,0>
	pPic1			PTR 0
	pPic2			PTR 0
	ptrStaticProc	PTR ?

CODE SECTION

START:
	invoke GetModuleHandle, 0
	mov [hInstance],eax
	invoke GdiplusStartup,offset GDIPlusToken,offset gdipsi,NULL
	invoke DialogBoxParam,[hInstance],1000,0,ADDR DlgProc,0
	invoke GdipDisposeImage,[pPic1]
	invoke GdipDisposeImage,[pPic2]
	invoke GdiplusShutdown,[GDIPlusToken]
	invoke ExitProcess,0

DlgProc FRAME hwnd,uMsg,wParam,lParam

	cmp D[uMsg],WM_INITDIALOG
	jne >.WM_CLOSE
		invoke GdipLoadImageFromFile,"basebmp.bmp",offset pPic1
		invoke GdipLoadImageFromFile,"basebmp2.bmp",offset pPic2
		invoke GetDlgItem,[hwnd],1001
		invoke SetWindowLong,eax,GWL_WNDPROC,offset StaticProc1
		mov [ptrStaticProc],eax
		invoke GetDlgItem,[hwnd],1002
		invoke SetWindowLong,eax,GWL_WNDPROC,offset StaticProc2
		jmp >.EXIT

	.WM_CLOSE
	cmp D[uMsg],WM_CLOSE
	jne >.DEFPROC
		INVOKE EndDialog,[hwnd],0

	.DEFPROC
		mov eax,FALSE
		ret

	.EXIT

	mov eax, TRUE
	ret
ENDF

StaticProc1 FRAME hwnd,uMsg,wParam,lParam
	LOCAL ps:PAINTSTRUCT
	LOCAL rect:RECT
	LOCAL pGraphics:%PTR

	.WM_PAINT
	cmp D[uMsg],WM_PAINT
	jne >>.DEFPROC
		invoke BeginPaint,[hwnd],offset ps
		invoke GetClientRect,[hwnd],offset rect

		invoke GdipCreateFromHDC,[ps.hdc], offset pGraphics
		invoke GdipSetInterpolationMode,[pGraphics],InterpolationModeHighQualityBicubic
		invoke GdipDrawImageRectI,[pGraphics],[pPic1],0,0,[rect.right], [rect.bottom]
		invoke GdipDeleteGraphics, [pGraphics]
		invoke EndPaint,[hwnd],offset ps

	.DEFPROC
	invoke CallWindowProc,[ptrStaticProc],[hwnd],[uMsg],[wParam],[lParam]
	RET
ENDF

StaticProc2 FRAME hwnd,uMsg,wParam,lParam
	LOCAL ps:PAINTSTRUCT
	LOCAL rect:RECT
	LOCAL pGraphics:%PTR

	.WM_PAINT
	cmp D[uMsg],WM_PAINT
	jne >>.DEFPROC
		invoke BeginPaint,[hwnd],offset ps
		invoke GetClientRect,[hwnd],offset rect

		invoke GdipCreateFromHDC,[ps.hdc], offset pGraphics
		invoke GdipSetInterpolationMode,[pGraphics],InterpolationModeHighQualityBicubic
		invoke GdipDrawImageRectI,[pGraphics],[pPic2],0,0,[rect.right], [rect.bottom]
		invoke GdipDeleteGraphics, [pGraphics]
		invoke EndPaint,[hwnd],offset ps

	.DEFPROC
	invoke CallWindowProc,[ptrStaticProc],[hwnd],[uMsg],[wParam],[lParam]
	RET
ENDF
